c
c ------------------------------------------------------------------
c
      subroutine hypbd(q,mitot,mjtot,meqn,mbc,work)
      implicit double precision (a-h,o-z)
      common /bcs/ ibc(4)
      dimension q(mitot,mjtot,meqn),work(meqn)
c 
c     # set physical boundary conditions
c     # **** for regular cells only ****
c
c     # left boundary
      go to (11,12,13) ibc(1)
c
 11   continue
c     # outflow
      do i=1,mbc
         do j=mbc+1,mjtot-mbc
            do m=1,meqn
               q(i,j,m) = q(mbc+1,j,m)
               enddo
            enddo
         enddo
      go to 20
c
 12   continue
c     # solid wall
      ico = 0
      do i=mbc,1,-1
         do j=mbc+1,mjtot-mbc  
            do m=1,meqn
               q(i,j,m) = q(mbc+1+ico,j,m)
               enddo
c
            q(i,j,2) = -q(i,j,2)
            enddo
         ico = ico+1
         enddo
      go to 20
c
 13   continue
c     # periodic
      ico = 0
      do i=mbc,1,-1
         do j=mbc+1,mjtot-mbc
            do m=1,meqn
               q(i,j,m) = q(mitot-mbc-ico,j,m)
               enddo
            enddo
         ico = ico+1
         enddo
      go to 20
c
c
 20   continue
c     # right boundary
      go to (21,22,23) ibc(3)
c
 21   continue
c     # outflow
      do i=mitot-mbc+1,mitot
         do j=mbc+1,mjtot-mbc
            do m=1,meqn
               q(i,j,m) = q(mitot-mbc,j,m)
               enddo
            enddo
         enddo
      go to 30
c
 22   continue
c     # solid wall
      ico = 0
      do i=mitot-mbc+1,mitot
         do j=mbc+1,mjtot-mbc
            do m=1,meqn
               q(i,j,m) = q(mitot-mbc-ico,j,m)
               enddo
c
            q(i,j,2) = -q(i,j,2)
            enddo
         ico = ico+1
         enddo
      go to 30
c
 23   continue
c     # periodic
      ico = 0
      do i=mitot-mbc+1,mitot
         do j=mbc,mjtot-mbc
            do m=1,meqn
               q(i,j,m) = q(mbc+1+ico,j,m)
               enddo
            enddo
         ico = ico+1
         enddo
      go to 30
c
 30   continue
c     # top boundary
      go to (31,32,33) ibc(2)
c
 31   continue
c     # outflow
      do j=mjtot-mbc+1,mjtot
         do i=1,mitot    
            do m=1,meqn
               q(i,j,m) = q(i,mjtot-mbc,m)
               enddo
            enddo
         enddo
      go to 40
c
 32   continue
c     # solid wall
      ico = 0
      do j=mjtot-mbc+1,mjtot
         do i=1,mitot
            do m=1,meqn
	       q(i,j,m) = q(i,mjtot-mbc-ico,m)
               enddo
c
            q(i,j,3) = -q(i,j,3)
            enddo
            ico = ico+1
         enddo
      go to 40
c
 33   continue
c     # periodic
      ico = 0
      do j=mjtot-mbc+1,mjtot
         do i=1,mitot
            do m=1,meqn
               q(i,j,m) = q(i,mbc+1+ico,m)
               enddo
            enddo
         ico = ico+1
         enddo
      go to 40
c
 40   continue
c     # bottom boundary
      go to (41,42,43) ibc(4)
c
 41   continue
c     # outflow
      do j=1,mbc
         do i=1,mitot
            do m=1,meqn
               q(i,j,m) = q(i,mbc+1,m)
               enddo
            enddo
         enddo
      return
c
 42   continue
c     # solid wall
      ico = 0
      do j=mbc,1,-1
         do i=1,mitot
            do m=1,meqn
               q(i,j,m) = q(i,mbc+1+ico,m)
               enddo
c
	    q(i,j,3) = -q(i,j,3)
            enddo
         ico = ico+1
         enddo
      return
c
 43   continue
c     # periodic 
      ico = 0
      do j=mbc,1,-1
         do i=1,mitot
            do m=1,meqn
               q(i,j,m) = q(i,mjtot-mbc-ico,m)
               enddo
            enddo
         ico = ico+1
         enddo
      return
c
      end
