c
c ------------------------------------------------------------------------
c
      integer function insbc(x0,y0,x1,y1,iptr,newbd)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
c
c     # check bond intersections
      do ibd=1,nbonds(iptr)
	 kbond = nbondc(ibd,iptr)
	 x2 = points(1,1,kbond)
	 y2 = points(1,2,kbond)
	 x3 = points(2,1,kbond)
	 y3 = points(2,2,kbond)
         sign0 = area2(x2,y2,x3,y3,x0,y0)
         sign1 = area2(x2,y2,x3,y3,x1,y1)
	 if (sign0*sign1 .lt. 0.d0) then
             write(6,*) 'bond intersection'
             stop
         endif
         enddo
c
c     # locate splitted subcell index
      do 29 icell=1,ncells(iptr)
c        # go through points on each subcell polygon and 
c        # identify subcell that has area sign changed (an
c        # indication that two adjacent polygonal points
c        # lie in different side of the directed segment
c        # (x0,y0)->(x1,y1))
c
         isbeg = 1
	 do 20 ii=1,10
	    if(poly(icell,ii,1,iptr) .eq. -99.d0) 
     &               go to 29
	    x2  = poly(icell,ii,1,iptr)
	    y2  = poly(icell,ii,2,iptr)
	    tmp = area2(x0,y0,x1,y1,x2,y2)
            if (tmp .eq. 0.d0) go to 20
            sign1 = dsign(1.d0,tmp)
c
            if (isbeg .eq. 1) then
                isbeg = 0
            else
	        if (sign0 .ne. sign1) go to 30
            endif
c
            sign0 = sign1
 20         continue
 29      continue
      go to 90
c
 30   continue
      insbc = icell
      return
c
 90   continue
      write(6,*) 'ERROR: fail to find splitted subcell'
      write(6,1005) iptr,ix(iptr),jy(iptr),
     &              ityirr(iptr)
      write(6,1001) x0,y0,x1,y1
      do 95 icell=1,ncells(iptr)
         write(6,1003) icell,ar(icell,iptr)
         do ii=1,10
            if(poly(icell,ii,1,iptr) .eq. -99.d0) go to 95
            write(6,1002) (poly(icell,ii,jj,iptr),jj=1,2)
            enddo
 95      continue
      stop
c
 1001 format('x1=',f12.6,', y1=',f12.6,', x2=',f12.6,', y2=',f12.6)
 1002 format(2f12.6)
 1003 format(i3,x,f14.10)
 1004 format('x=',f12.6,', y=',f12.6,', sign0=', f12.8,
     &       ', sign1=',f12.8)
 1005 format('iptr=',i3,', ix=',i3,', jy=',i3,', ityirr=',i3)
      end
