c
c ---------------------------------------------------------------
c
      subroutine irrst0(q,qirr,mitot,mjtot,meqn,lstgrd)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension q(mitot,mjtot,meqn),qirr(6,20,maxbd)
c
c     # update values on uniform grid cells
c
      iptr = lstgrd
      do ik=1,maxbd
         iptr = iabs(nxtirr(iptr))
         if (iptr .eq. 0) go to 199
         i = ix(iptr)
         j = jy(iptr)
c
         area = 0.d0
         do m=1,meqn
            q(i,j,m) = 0.d0
            enddo
c
c        # compute cell average
         do icell=1,ncells(iptr)
            do m=1,meqn
               q(i,j,m) = q(i,j,m)+
     &                    ar(icell,iptr)*qirr(icell,m,iptr)
               enddo
c
	    area = area+ar(icell,iptr)
            enddo
c
         do m=1,meqn
            q(i,j,m) = q(i,j,m)/area
            enddo
         enddo
 199  continue
c
      return
      end
