c
c --------------------------------------------------------------------
c
      integer function maptr(itype)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100,maxbd=5560)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkfront/ iprfront(maxfr),nxtfront(maxfr),
     &                 ityfront(maxfr),newfront(maxfr),
     &                 lstbond(maxfr),mwfront(maxfr),
     &                 loops(maxfr),ityloop1(maxfr)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
c
c     # get pointer for a irregular cell or a tracked front
c
      nextk = lstptr(itype)
c
      if (itype .eq. 1) then
c         # irregular cell
          k0 = iprirr(nextk)
          nxtirr(k0) = nextk
c
          k = nextk
          nxtirr(k) = 0
          iprirr(k) = k0
          ityirr(k) = 1
          ncells(k) = 1
	  nbonds(k) = 0
      elseif (itype .eq. 2) then
c         # tracked front
	  k0 = iprfront(nextk)
	  nxtfront(k0) = nextk
c
	  k = nextk
	  nxtfront(k) = 0
	  iprfront(k) = k0
	  newfront(k) = 1
      elseif (itype .eq. 3) then
c         # tracked bond
	  k0 = iprbond(nextk)
	  nxtbond(k0) = nextk
c
	  k = nextk
	  nxtbond(k) = 0
	  iprbond(k) = k0
	  itybond(k) = 0
      else
	  write(6,*) 'no pointer available for itype=',itype
	  stop
      endif
c
      maptr = k
c
      return
      end
