c
c -------------------------------------------------------------------
c
      subroutine newvof(vof,irr,mitot,mjtot,lstgrd)  
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ixc(maxbd),jyc(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      common /param/ epsar,hsize,tol
      dimension vof(mitot,mjtot),irr(mitot,mjtot)
c
c     # set volume of fluid states
c
      vof1 = 1.d0
      vof2 = 0.d0
c
      eps = epsar/ar(1,lstgrd)
c
c     # for regular cells
      do i=1,mitot
         do j=1,mjtot
            if (vof(i,j) .lt. eps) then
                vof(i,j) = vof2
            elseif (vof(i,j) .gt. 1.0-eps) then
                vof(i,j) = vof1
            endif
            enddo
         enddo
c
c     # for irregular cells
      iptr = lstgrd
      do ik=1,maxbd
         iptr = nxtirr(iptr)
         if(iptr .eq. 0) go to 19 
c
         ix = ixc(iptr)
         jy = jyc(iptr)
         iptr = irr(ix,jy)
c
         do ibd=1,nbonds(iptr)
            kbond = nbondc(ibd,iptr)
            irrl = irrcell(1,kbond)
            irrr = irrcell(2,kbond)
            vofir(irrl,iptr) = vof1
            vofir(irrr,iptr) = vof2
            enddo
         enddo
 19   continue
      return
c
      end
