c
c ---------------------------------------------------------
c
      subroutine outvar(q,vof,irr,mitot,mjtot,meqn,lstgrd,work,
     &                  mbc,io2d,iunit)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd) 
      dimension q(mitot,mjtot,meqn),vof(mitot,mjtot)
      dimension irr(mitot,mjtot),work(meqn)
c
c     # output state variables
c
      if (io2d .eq. 0) return   
c
      do i=mbc+1,mitot-mbc
         do j=mbc+1,mjtot-mbc
            if (irr(i,j) .eq. -lstgrd) then
                write(iunit,*) 'NaN NaN NaN NaN NaN NaN NaN NaN'
            elseif ((irr(i,j) .ne. lstgrd) .and.
     &              (io2d .eq. 2)) then
                write(iunit,*) 'NaN NaN NaN NaN NaN NaN NaN NaN'
c
                iptr = irr(i,j)
                do icell=1,ncells(iptr)
                   do m=1,meqn
                      work(m) = qirr(icell,m,iptr)
                      enddo
c
                   call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,
     &                         gru0,gam0,alp0,bet0,pn0,psi0)
c
                   tau = 1.d0/rho
                   temp = (tau-bet0)*(p+pn0+alp0/tau**2)
c
                   write(121,1001) rho,u,v,p,temp,gam0,psi0,
     &                             vofir(icell,iptr)
c
                   npts = 0
                   do ii=1,20
                      if (poly(icell,ii,1,iptr) .eq. -99.d0)
     &                    go to 19
                      write(122,1002) poly(icell,ii,1,iptr),
     &                                poly(icell,ii,2,iptr)
                      npts = npts+1
                      enddo
 19                continue
c
                   write(123,*) npts
                   enddo
            else
                do m=1,meqn
                   work(m) = q(i,j,m)
                   enddo
c
                call ctoprm(work,rho,u,v,rhoe,rhok,p,gamma,gru0,
     &                      gam0,alp0,bet0,pn0,psi0)
c
                tau = 1.d0/rho
                temp = (tau-bet0)*(p+pn0+alp0/tau**2)
c
                write(iunit,1001) rho,u,v,p,temp,gam0,psi0,vof(i,j)
            endif
            enddo
         enddo
c
 1001 format(8f24.10)
 1002 format(2f16.8)
c
      return
      end
