c
c -----------------------------------------------------------------------
c
      subroutine setgrd(vof,irr,mitot,mjtot,xlow,ylow,hx,hy,lstgrd,
     &                  lstfrt,iprob,itrack)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100,maxbd=5560)
      common /frontin/ xloop(maxfr),yloop(maxfr),rloop(maxfr),
     &       varloop(5,maxfr,maxfr),stdev(maxfr),ityloop(maxfr),
     &       ibdloop(maxfr),mwloop(maxfr),istloop(maxfr),
     &       newloop(maxfr),nloops,nfourier(maxfr),nrand(maxfr)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkfront/ iprfront(maxfr),nxtfront(maxfr),
     &                 ityfront(maxfr),newfront(maxfr),
     &                 lstbond(maxfr),mwfront(maxfr),
     &                 loops(maxfr),ityloop1(maxfr)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension vof(mitot,mjtot),irr(mitot,mjtot)
c
c     # set front structure & also the grid
c
      nxtirr(lstgrd) = 0
      nxtfront(lstfrt) = 0
c
c     # initialize the irregular cell arrays
      do i=1,mitot
         do j=1,mjtot
            irr(i,j) = lstgrd
            enddo
         enddo
c
      area0 = hx*hy
      do icell=1,6
         do iptr=1,maxbd
            ar(icell,iptr)= area0
            enddo
         enddo
c
c     # initialize volume of fluid 
      call initv(vof,mitot,mjtot,xlow,ylow,hx,hy,iprob,iloop)
c
      if (itrack .eq. 0) return
c
c     # initialize front structure
      newfr = maptr(2)
      newfront(newfr) = 0
      ityfront(newfr) = ibdloop(iloop)
      lstbond(newfr) = lstptr(3)
c
      mwfront(newfr)  = mwloop(iloop)
      ityloop1(newfr) = ityloop(iloop)
c
c     # create grids
      kbond0 = lstbond(newfr)
      call vofint(vof,irr,mitot,mjtot,xlow,ylow,hx,hy,
     &            area0,lstgrd,kbond0)  
c
c     # set front type
      call typfrt(newfr,ibdloop(iloop))
c
c     # set edge-cell relation
      call edgcel(xlow,ylow,hx,hy,lstgrd)
c
      return
      end
