c
c ------------------------------------------------------------------
c
      subroutine setpar(mitot,mjtot,mbc,iorder,hx,hy)
      implicit double precision (a-h,o-z)
      common /epscomp/ epsc
      common /domain/ corn(2,2)
      common /mathc/ pi
      common /param/ epsar,hsize,tol
c
c     # set up parameters used in the program
c
c     # compute pi
      pi = 4.d0*datan(1.d0)
c
c     # compute machine constant
      epsc = 1.d0
 10   epsc = epsc/2.d0
      t = 1.d0+epsc
      if (t .gt. 1.0d0) go to 10
      tol = 100.d0*epsc
c
c     # tolerance of small cells
      area0 = hx*hy
      frac = 1.d-7
      epsar = dmax1(frac*area0,tol)
c
      hsize = dmax1(hx,hy)
c
c     # numerical boundary zones
      mbc = iorder
c
c     # total number of cells
      mitot = idnint((corn(1,2)-corn(1,1))/hx)+2*mbc
      mjtot = idnint((corn(2,2)-corn(2,1))/hy)+2*mbc
c
      write(6,1001) mitot,mjtot,epsc,epsar,tol
c
 1001 format(' mitot                   ',i5,/,
     &       ' mjtot                   ',i5,/,
     &       ' machine constant        ',e12.6,/,
     &       ' tolerance of small cell ',e12.6,/,
     &       ' scaled tolerance        ',e12.6,/)
c
      return
      end
