c
c ---------------------------------------------------------------------
c
      subroutine vofint(vof,irr,mitot,mjtot,xlow,ylow,hx,hy,area0,
     &                  lstgrd,kbond0)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ixc(maxbd),jyc(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      common /param/ epsar,hsize,tol
      dimension irr(mitot,mjtot),vof(mitot,mjtot)
c
c     # routine for interface reconstruction based on vof
c
      eps = epsar/area0
      ismall = 0
c
      do i=1,mitot
         do j=1,mjtot
            if ((vof(i,j) .ge. eps) .and. (vof(i,j) .le. 1.0-eps)) then
c               # determine slope or the normal direction of an
c               # interface within cell (i,j)
                call vofem(i,j,vof,mitot,mjtot,xlow,ylow,
     &                     hx,hy,alf,beta)
c   
c               # interface reconstruction
                call vofrc(i,j,vof(i,j),alf,beta,xlow,ylow,hx,hy,
     &                     area0,x1,y1,x2,y2)
c
c               # make irregular cell
                call mkirrc(irr,i,j,x1,y1,x2,y2,mitot,mjtot,
     &               xlow,ylow,hx,hy,lstgrd,kbond0,kbond,ismall)
c
                if (ismall .eq. 1) write(6,*) 'vof=',vof(i,j)
            endif
            enddo
         enddo
c
      if (ismall .eq. 1) then
          write(6,1001) kbond
c
          call putptr(kbond,3)
          nxtbond(kbond0) = 0
          ix = ixbond(kbond0)
          jy = jybond(kbond0)
          nxtirr(irr(ix,jy)) = 0
      endif
c
 1001 format('ismall= 1, bond=',i4)
c 
      return
      end
