c
c ------------------------------------------------------------------
c
      subroutine wsqge(wsq,zw0,rho,pstar,rho0,p0,csq0,gam0,
     &                 alp0,bet0,pn0)
      implicit double precision (a-h,o-z)
      common /roots/ dp,dp2,rho00,pstar0,e0,gam00,alp00,
     &               bet00,pn00
      external hugnot
c
c     # compute Lagrangian wave speed
c
      gasc = 0.5d0*(gam0+1.d0)/gam0
      pp   = (pstar+pn0)/(p0+pn0)
      wsq = csq0*(1.d0+gasc*(pp-1.d0))
      dp  = pstar-p0
c
      if (alp0 .ne. 0.d0) then
          dp2  = (pstar+p0)*dp
          gru0 = (1.0d0-rho0*bet0)/(gam0-1.d0)
          alpr2 = alp0*rho0*rho0
          e0   = (gru0*(p0+pn0+alpr2)+(pn0-alpr2))/rho0
c
          pstar0 = pstar
          rho00 = rho0
          gam00 = gam0
          alp00 = alp0
          bet00 = bet0
          pn00  = pn0
c
          if (dabs(hugnot(wsq)) .gt. 1.d-8) then
              wsq0 = rho0*gam0/(1.d0-rho0*bet0)*(p0+pn0)*
     &               (1.d0+gasc*(pp-1.d0)) 
c
              if (dabs(hugnot(wsq0)) .gt. 1.d-8) then
                  aa = wsq0
                  bb = wsq
c                  write(6,*) 'initial wsq=',wsq, ', wsq0=',wsq0
c
                  wsq = zeroin(aa,bb,hugnot,1.d-8)
c
c                  write(6,*) 'root-finding wsq=',wsq
              else
                  wsq = wsq0
              endif
          endif
      endif
c
      rho = rho0/(1.d0-rho0*dp/wsq)
      zw0 = 2.d0*wsq/(wsq+csq0)
c
      return
      end
