fid = fopen('t0/fort.51');
info = fscanf(fid,'%d %d %d %g %g %g %g',8);
status = fclose(fid);
%
mitot = info(1);
mjtot = info(2);
ix1 = info(3)+1;
ixn = mitot-info(3);
jy1 = info(3)+1;
jyn = mjtot-info(3);
xcorn = info(4);
ycorn = info(5);
hx = info(6);
hy = info(7);
meqn = info(8);
nrow = jyn-jy1+1;
ncol = ixn-ix1+1;
x = xcorn+(0:ncol)*hx;
y = ycorn+(0:nrow)*hy;
%
% t=0
fid = fopen('t0/plot.3');
data0 = fscanf(fid,'%g',[8 nrow*ncol]);
data0 = data0';
status = fclose(fid);
%
% t = 1
fid = fopen('t1/plot.3');
data1 = fscanf(fid,'%g',[8 nrow*ncol]);
data1 = data1';
status = fclose(fid);
%
% t = 2
fid = fopen('t2/plot.3');
data2 = fscanf(fid,'%g',[8 nrow*ncol]);
data2 = data2';
status = fclose(fid); 
%
% t = 4
fid = fopen('t4/plot.3');
data3 = fscanf(fid,'%g',[8 nrow*ncol]);
data3 = data3';
status = fclose(fid);
%                     
% t = 6
fid = fopen('t6/plot.3');
data4 = fscanf(fid,'%g',[8 nrow*ncol]);
data4 = data4';
status = fclose(fid);
%                     
% t = 8
fid = fopen('t8/plot.3');
data5 = fscanf(fid,'%g',[8 nrow*ncol]);
data5 = data5';
status = fclose(fid);
%                     
% Density
m = 1;
rho = reshape(data0(:,m),nrow,ncol);
rho0 = ones(nrow+1,ncol+1);
rho0(1:nrow,1:ncol) = rho;
rho0(1:nrow,ncol+1) = rho(:,ncol);
rho0(nrow+1,1:ncol) = rho(nrow,:);
rho0(nrow+1,ncol+1) = rho(nrow,ncol);
rho0 = rho0/10^3;
%
rho = reshape(data1(:,m),nrow,ncol);
rho1 = ones(nrow+1,ncol+1);
rho1(1:nrow,1:ncol) = rho;
rho1(1:nrow,ncol+1) = rho(:,ncol);
rho1(nrow+1,1:ncol) = rho(nrow,:);
rho1(nrow+1,ncol+1) = rho(nrow,ncol);
rho1 = rho1/10^3;
%
rho = reshape(data2(:,m),nrow,ncol);
rho2 = ones(nrow+1,ncol+1);
rho2(1:nrow,1:ncol) = rho;
rho2(1:nrow,ncol+1) = rho(:,ncol);
rho2(nrow+1,1:ncol) = rho(nrow,:);
rho2(nrow+1,ncol+1) = rho(nrow,ncol);
rho2 = rho2/10^3;
%
rho = reshape(data3(:,m),nrow,ncol);
rho3 = ones(nrow+1,ncol+1);
rho3(1:nrow,1:ncol) = rho;
rho3(1:nrow,ncol+1) = rho(:,ncol);
rho3(nrow+1,1:ncol) = rho(nrow,:);
rho3(nrow+1,ncol+1) = rho(nrow,ncol);
rho3 = rho3/10^3; 
%
rho = reshape(data4(:,m),nrow,ncol);
rho4 = ones(nrow+1,ncol+1);
rho4(1:nrow,1:ncol) = rho;
rho4(1:nrow,ncol+1) = rho(:,ncol);
rho4(nrow+1,1:ncol) = rho(nrow,:);
rho4(nrow+1,ncol+1) = rho(nrow,ncol);
rho4 = rho4/10^3; 
%
rho = reshape(data5(:,m),nrow,ncol);
rho5 = ones(nrow+1,ncol+1);
rho5(1:nrow,1:ncol) = rho;
rho5(1:nrow,ncol+1) = rho(:,ncol);
rho5(nrow+1,1:ncol) = rho(nrow,:);
rho5(nrow+1,ncol+1) = rho(nrow,ncol);
rho5 = rho5/10^3; 
%
rmin = 1e16;
rmax = -1e16;
rmin = min(rmin,min(min(rho0)));
rmax = max(rmax,max(max(rho0)));
rmin = min(rmin,min(min(rho1)));
rmax = max(rmax,max(max(rho1))); 
rmin = min(rmin,min(min(rho2)));
rmax = max(rmax,max(max(rho2))); 
rmin = min(rmin,min(min(rho3)));
rmax = max(rmax,max(max(rho3)));  
rmin = min(rmin,min(min(rho4)));
rmax = max(rmax,max(max(rho4)));  
rmin = min(rmin,min(min(rho5)));
rmax = max(rmax,max(max(rho5)));  
%
subplot(3,2,1);
pcolor(x,y,rho0);
shading flat;
yrbcolormap;
caxis([rmin, rmax]);
%caxis('auto');
%colorbar;
axis off;
axis image;
%
subplot(3,2,2);
pcolor(x,y,rho1);
shading flat;
yrbcolormap;
caxis([rmin, rmax]); 
%caxis('auto');
%colorbar;
axis off;
axis image;
%
subplot(3,2,3);
pcolor(x,y,rho2);
shading flat;
yrbcolormap;
caxis([rmin, rmax]);
%caxis('auto');
%colorbar;
axis off;
axis image;
%
subplot(3,2,4);
pcolor(x,y,rho3);
shading flat;
yrbcolormap;
caxis([rmin, rmax]);
%caxis('auto');
%colorbar;
axis off;
axis image;
%
subplot(3,2,5);
pcolor(x,y,rho4);
shading flat;
yrbcolormap;
caxis([rmin, rmax]);
%caxis('auto');
%colorbar;
axis off;
axis image;
%
subplot(3,2,6);
pcolor(x,y,rho4);
shading flat;
yrbcolormap;
caxis([rmin, rmax]);
%caxis('auto');
%colorbar;
axis off;
axis image;
%
jointfig(gcf,3,2)
