c
c --------------------------------------------------------------
c
      subroutine celave(xlow,ylow,hx,hy,area0,wl)
      implicit double precision (a-h,o-z)
      common /fsscoef/ a00,a10,b00,b10
      common /intar/ area,xc,yc
      dimension x(10),y(10),poly(20,2)
      external fss
      logical fl(5),alll,allr
c   
c     # compute wl, fraction of cell that lies in left state.
c     # for initial data with two states ql and qr separated by a 
c     # discontinuity, specified by fintf (<0 to left, >0 to right)
c
      poly(1,1) = xlow
      poly(1,2) = ylow
      poly(2,1) = xlow
      poly(2,2) = ylow+hy
      poly(3,1) = xlow+hx
      poly(3,2) = ylow+hy
      poly(4,1) = xlow+hx
      poly(4,2) = ylow
      poly(5,1) = xlow
      poly(5,2) = ylow
      poly(6,1) = -99.d0
      poly(6,2) = -99.d0
c
      alll = .true.
      allr = .true.
      do 20 i=1,4
	 fl(i) = fintf(poly(i,1),poly(i,2)) .lt. 0.d0
	 alll  = alll .and. fl(i)
	 allr  = allr .and. (.not. fl(i))
 20      continue
      fl(5) = fl(1)
c
      if (alll) then
	  wl = 1.d0
	  return
      endif
c
      if (allr) then
	  wl = 0.d0
	  return
      endif
c
      iv = 0
      do 40 i=1,4
         if (fl(i)) then
	     iv = iv+1
	     x(iv) = poly(i,1)
	     y(iv) = poly(i,2)
         endif
c
         if (fl(i) .neqv. fl(i+1)) then
	     iv = iv+1
             a00 = poly(i,1)
             a10 = poly(i+1,1)-poly(i,1)
             b00 = poly(i,2)
             b10 = poly(i+1,2)-poly(i,2)
	     z   = zeroin(0.d0,1.d0,fss,tol)
             x(iv) = a00+a10*z
             y(iv) = b00+b10*z
	 endif
 40      continue
c
      if (iv.eq.0) then
	  wl = 0.d0
	  return
      endif
c
      do ii=1,iv
         poly(ii,1) = x(ii)
         poly(ii,2) = y(ii)
         enddo
c
      poly(iv+1,1) = x(1)
      poly(iv+1,2) = y(1)
      poly(iv+2,1) = -99.d0
      poly(iv+2,2) = -99.d0
c
c     # compute area & cell center
      call cent2d(poly,xc,yc,area)
c
      if (area .lt. 1.d-15) then
          area = 0.d0
      elseif (area .ge. area0-1.d-15) then
          area = area0
      endif
c
      wl = area/area0
c
      return
      end
