c
c  -----------------------------------------------------------
c
      subroutine free(index,nwords)
      implicit double precision (a-h,o-z)
      common /space/ lhead(6),lfree(50,2),lenf,idimf,lentot,lenmax 
      data isprint/0/
c
c     # return of space. add to free list.
c     # iplace points to next item on free list with larger index 
c     # than the item reclaiming, unless said item is greater then
c     # everything on the list.
c
      if (isprint .eq. 1) then
          write(6,*) 'entering free routine'
          write(6,1001) (lfree(i,1),i=1,lenf)
          write(6,1002) (lfree(i,2),i=1,lenf)
      endif
c
      do i=1,lenf
         iplace = i
         if (lfree(i,1) .gt. index) go to 30
         enddo
c
      write(6,902)
 902  format(' no insertion pointer into freelist. error stop')
      stop
c
c     # check previous segment for merging
 30   iprev = iplace - 1
      if (lfree(iprev,1)+lfree(iprev,2) .lt. index) go to 40
          lfree(iprev,2) = lfree(iprev,2) + nwords
          go to 50
c
c     # check after segment - no previous merge case
 40   nexti = index + nwords
      if (lfree(iplace,1).ne. nexti) go to 70
          lfree(iplace,1) = index
          lfree(iplace,2) = lfree(iplace,2) + nwords
          go to 99
c
c     # check following segment - yes previous merge case
 50   nexti = index + nwords
      if (lfree(iplace,1) .ne. nexti) go to 99
c
c     # forward merge as well, bump all down 1
      lfree(iprev,2) = lfree(iprev,2)+lfree(iplace,2)
      ipp1           = iplace + 1
      do i=ipp1,lenf
         lfree(i-1,1) = lfree(i,1)
         lfree(i-1,2) = lfree(i,2)
         enddo
      lenf = lenf - 1
      go to 99
c
c     # no merges case - insert and bump future segments up to make room
 70   if (lenf .eq. idimf) go to 900
      do ii=iplace,lenf
         i          = lenf + 1 - ii + iplace
         lfree(i,1) = lfree(i-1,1)
         lfree(i,2) = lfree(i-1,2)
         enddo
      lenf            = lenf + 1
      lfree(iplace,1) = index
      lfree(iplace,2) = nwords
      go to 99
c
 900  write(6,901) idimf
 901  format('  free list full with ',i5,' items')
      stop
c
 99   lentot = lentot - nwords
      if (isprint .eq. 1) then
         write(6,*) 'leaving free routine'
         write(6,1001) (lfree(i,1),i=1,lenf)
         write(6,1002) (lfree(i,2),i=1,lenf)
         write(6,100) nwords,index,lentot
      endif
c
 100  format('     reclaiming ',i5,' words at loc. ',i5,' lentot ',i10)
 1001 format('lfree(i,1) = ',6i7)
 1002 format('lfree(i,2) = ',6i7)
c
      return
      end
