c
c --------------------------------------------------------------
c
      subroutine gsrc(g,gfrac,rho,u,v,rhoe,rhok,p,gam0,alp0,
     &                bet0,pn0)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100)
      common /fluid/ geos(maxfr),alp(maxfr),bet(maxfr),pnf(maxfr),
     &               zf(maxfr),zpsi(maxfr),mphase  
      dimension g(20)
c
c     # geometric source term
c
      rhou  = rho*u
      rhouv = rhou*v
      phi  = 1.d0/(gam0-1.d0)
      psi  = rho*bet0*phi
      qsi  = psi*pn0       
      rsi  = (2.d0*phi-(2.d0+3.d0*psi))*alp0*rho*rho
      rhoh = rhoe+rhok+p
c
      g(1) = gfrac*rhou
      g(2) = gfrac*rhou**2/rho
      g(3) = gfrac*rhouv
      g(4) = gfrac*rhoh*u
      g(5) = 0.d0
      g(6) = gfrac*psi*u
      g(7) = -gfrac*qsi*u
      g(8) = gfrac*rsi*u
c
      go to (1,2) mphase
c
 1    continue
c     # gamma-based version
c
      g(9) = 0.d0
      g(10) = 0.d0
      return
c
 2    continue
c     # gamma-based version    
c     # iclude total kinetic energy
c
      g(9) = 0.d0
      g(10) = gfrac*rhok*u
      g(11) = 0.d0
      return
c
      end
