c
c ------------------------------------------------------------------------
c
      double precision function hugnot(ws2)
      implicit double precision (a-h,o-z)
      common /roots/ dp,dp2,rho0,pstar,e0,gam0,alp0,
     &               bet0,pn0 
c
c     # Shock Hugoniot relation
c
      rho1 = rho0/(1.d0-rho0*dp/ws2)
      gru1 = (1.0d0-rho1*bet0)/(gam0-1.d0)
      alpr2 = alp0*rho1*rho1
      e1 = (gru1*(pstar+pn0+alpr2)+(pn0-alpr2))/rho1
      hugnot = (e1-e0)-0.5d0*(dp2/ws2)
c
c      write(6,*) ws2,hugnot
      return
      end
