c
c -----------------------------------------------------------------------
c
      subroutine limter(work,qja,qjb,meqn,islope,meth)
      implicit double precision (a-h,o-z)
      dimension work(meqn),qja(20),qjb(20)
c
c     # compute limited slope
c
      do m=1,meqn
         work(m) = 0.d0
         enddo
c
      go to (1,2,3,4) islope
c
 1    continue
c     # limit over each component of jumps separately   
      do m=1,meqn
         if (qja(m) .ne. 0.d0) 
     &       work(m) = philim(qja(m),qjb(m),meth)*
     &                        qja(m)
         enddo
c
      qja0 = qja(4)-qja(7)-qja(8)
      qjb0 = qjb(4)-qjb(7)-qjb(8)
      if (qja0 .ne. 0.d0) then
          work0 = philim(qja0,qjb0,meth)*qja0
      else
          work0 = 0.d0
      endif
      work(4) = work0+work(7)+work(8)
      return
c
 2    continue
c     # limit over each component of jumps separately
      do m=1,meqn
         if (qja(m) .ne. 0.d0)
     &       work(m) = philim(qja(m),qjb(m),meth)*qja(m)
         enddo
c
c     # total energy
      qja0 = qja(4)-qja(7)-qja(8)-qja(10)
      qjb0 = qjb(4)-qjb(7)-qjb(8)-qjb(10)
      if (qja0 .ne. 0.d0) then
          work0 = philim(qja0,qjb0,meth)*qja0
      else
          work0 = 0.d0
      endif
      work(4) = work0+work(7)+work(8)+work(10)
      return
c
 3    continue
c     # limit over each component of jumps separately
      do m=1,meqn
         if (qja(m) .ne. 0.d0)
     &       work(m) = philim(qja(m),qjb(m),meth)*
     &                        qja(m)
         enddo
c
      qja0 = qja(4)-qja(7)
      qjb0 = qjb(4)-qjb(7)
      if (qja0 .ne. 0.d0) then
          work0 = philim(qja0,qjb0,meth)*qja0
      else
          work0 = 0.d0
      endif
      work(4) = work0+work(7)
      return 
c
 4    continue
c     # limit over each component of jumps separately
      do m=1,meqn
         if (qja(m) .ne. 0.d0)
     &       work(m) = philim(qja(m),qjb(m),meth)*qja(m)
         enddo
c
c     # total energy
      qja0 = qja(4)-qja(7)-qja(10)
      qjb0 = qjb(4)-qjb(7)-qjb(10)
      if (qja0 .ne. 0.d0) then
          work0 = philim(qja0,qjb0,meth)*qja0
      else
          work0 = 0.d0
      endif
      work(4) = work0+work(7)+work(10)
      return
c
      end
