c
c ------------------------------------------------------------------
c
      integer function maloc(nwords)
      implicit double precision (a-h,o-z)
      common /space/ lhead(6),lfree(50,2),lenf,idimf,lentot,lenmax
      logical sprint
      data sprint/.false./
c
c     # allocate contiguous space of length nword in main storage array
c     # alloc. user code (or pointer to the owner of this storage)
c     # is mptr. lenf = current length of lfree list.
c
c     # find first fit from free space list
      itake = 0
      do 20 i=1,lenf
         if (lfree(i,2) .lt. nwords) go to 20
         itake = i
         go to 25
 20      continue
      go to 900
c
c     # put remaining words back on list.
 25   left = lfree(itake,2) - nwords
      maloc = lfree(itake,1)
c
c     # the following code which is ignored for now adds the new
      if (left .le. 0) go to 30
          lfree(itake,2) = left
          lfree(itake,1) = lfree(itake,1) + nwords
      go to 99
c
c     # item is totally removed.  move next items in list up one.
 30   lenf = lenf-1
      do i=itake,lenf
         lfree(i,1) = lfree(i+1,1)
         lfree(i,2) = lfree(i+1,2)
         enddo
      go to 99
c
 900  write(6,901) nwords
 901  format('  require ',i10,' words - either none left or not big',
     &         '  enough space')
      write(6,902) ((lfree(i,j),j=1,2),i=1,lenf)
 902  format(' free list: ',//,2x,50(i10,4x,i10,/,2x))
c      call outtre(mstart,.false.,nvar)
      stop
c
 99   lentot = lentot+nwords
      if (lenmax .lt. lentot) lenmax = lentot
      if (sprint) write(6,100) nwords, maloc, lentot, lenmax
 100  format('  allocating ',i5,' words in location ',i5,
     &       ' lentot, lenmax ', 2i10)
c
      return
      end
