c
c ----------------------------------------------------------------
c
      subroutine mkgrid(q,qold,vof,vofold,irr,irrold,mitot,mjtot,
     &                  meqn,lstgrd,lstold)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension irr(mitot,mjtot),irrold(mitot,mjtot)
      dimension q(mitot,mjtot,meqn),qold(mitot,mjtot,meqn)
      dimension vof(mitot,mjtot),vofold(mitot,mjtot)
c
c     # make new grid preliminary
c
c     # save the old grid states 
c     # for solution states
      call irrst0(q,qirr,mitot,mjtot,meqn,lstgrd)
c
      do i=1,mitot
         do j=1,mjtot
            do m=1,meqn
               qold(i,j,m) = q(i,j,m)
               enddo
            enddo
         enddo
c
c     # for volume of fluid
      call irrst1(vof,vofir,mitot,mjtot,lstgrd)
c
      do i=1,mitot
         do j=1,mjtot
            vofold(i,j) = vof(i,j)
            enddo
         enddo
c
c     # copy irregular cell pointers
      do i=1,mitot
	 do j=1,mjtot
	    irrold(i,j) = irr(i,j)
            enddo
         enddo
      lstold = lstgrd
c
c     # set new grid pointer
      lstgrd = lstptr(1)
      nxtirr(lstgrd) = 0
      do i=1,mitot
	 do j=1,mjtot
	    if (irrold(i,j) .eq. -lstold) then
	        irr(i,j) = -lstgrd
	    else
	        irr(i,j) = lstgrd
	    endif
            enddo
         enddo
      ar(1,lstgrd) = ar(1,lstold)
c
      return
      end
