c
c ---------------------------------------------------------------
c
      subroutine mkpowv(poly,x1,y1,x2,y2,ddx,ddy,is,itype)
      implicit double precision (a-h,o-z)
      dimension poly(20,2)
c
c     # create a polygon poly representing this wave,
c     # going clockwise around wave:
c
      go to (1,2) itype
c
 1    continue
c     # make poly from fixed cell interface
      poly(1,1)    = x1
      poly(1,2)    = y1
      poly(3-is,1) = x2 
      poly(3-is,2) = y2 
      poly(3,1)    = x2+ddx
      poly(3,2)    = y2+ddy
      poly(3+is,1) = x1+ddx
      poly(3+is,2) = y1+ddy
      poly(5,1)    = x1
      poly(5,2)    = y1
      poly(6,1)    = -99.d0
      poly(6,2)    = -99.d0
      return
c
 2    continue
c     # make poly from tracked interface
      poly(1,1)    = x1
      poly(1,2)    = y1
      poly(3-is,1) = x1+ddx
      poly(3-is,2) = y1+ddy
      poly(3,1)    = x2+ddx
      poly(3,2)    = y2+ddy
      poly(3+is,1) = x2
      poly(3+is,2) = y2
      poly(5,1)    = x1
      poly(5,2)    = y1
      poly(6,1)    = -99.d0
      poly(6,2)    = -99.d0
      return  
c
      end
