c
c -------------------------------------------------------------------
c
      subroutine newqir(qold,irr,irrold,mitot,mjtot,meqn,lstgrd,
     &                  lstold)
      implicit double precision (a-h,o-z)
      parameter(maxbd=5560)
      common /irrst/ vofir(6,maxbd),qirr(6,20,maxbd)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ixc(maxbd),jyc(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension qold(mitot,mjtot,meqn)
      dimension irr(mitot,mjtot),irrold(mitot,mjtot)
      dimension po1(20,2),po2(20,2),po3(20,2)
c
c     # initialize new irregular cells
c
      iptr = lstgrd
      do ik=1,maxbd
         iptr = nxtirr(iptr)
         if(iptr .eq. 0) go to 99
c
         ix = ixc(iptr)
         jy = jyc(iptr)
	 iptr1 = irrold(ix,jy)
	 if (iptr1 .ne. lstold) then
c            # irregular cell case
             do icell=1,ncells(iptr)
                do jj=1,2
                   do ii=1,10
                      po1(ii,jj) = poly(icell,ii,jj,iptr)
                      enddo
                   enddo
c
                do m=1,meqn
                   qirr(icell,m,iptr) = 0.d0
                   enddo
c
c               # assign cell values based on area weighted cell averages
                do icold=1,ncells(iptr1)
                   do jj=1,2
                      do ii=1,10
                         po2(ii,jj) = poly(icold,ii,jj,iptr1)
                         enddo
                      enddo
c
                   call poin2d(po1,po2,po3,area)
c
                   frac = area/ar(icell,iptr)
                   do m=1,meqn
                      qirr(icell,m,iptr) = qirr(icell,m,iptr)+
     &                     frac*qirr(icold,m,iptr1)
                      enddo
                   enddo
                enddo
         else
c            # regular cell case
             do icell=1,ncells(iptr)
                do m=1,meqn
                   qirr(icell,m,iptr) = qold(ix,jy,m)
                   enddo
                enddo
         endif
         enddo
 99   continue
      return
c
      end
