c
c ------------------------------------------------------------------------
c
      subroutine polar(r,theta,x,y,x0,y0)
      implicit double precision (a-h,o-z)
      common /mathc/ pi
c   
c     # transform the (x,y) Cartesian coordinate to 
c     # the (r-theta) polar coordinate
c
      r = dsqrt((x-x0)**2+(y-y0)**2)
      if(r .eq. 0.d0) then
         theta = 0.d0
      else
         theta = dasin((y-y0)/r)/pi
      endif
c
      if(((x-x0).ge.0.d0) .and. ((y-y0).ge.0.d0)) then
c        # first quadrant
         theta = theta
      elseif(((x-x0).le.0.d0) .and. ((y-y0).ge.0.d0)) then
c        # second quadrant
         theta = -theta+1.d0
      elseif(((x-x0).le.0.d0) .and. ((y-y0).le.0.d0)) then
c        # third quadrant
         theta = -theta+1.d0
      elseif(((x-x0).ge.0.d0) .and. ((y-y0).le.0.d0)) then
c        # fourth quadrant
         theta = theta+2.0d0
      endif
c
      return
      end
