c
c -------------------------------------------------------------
c
      subroutine putptr(iptr,itype)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100,maxbd=5560)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkfront/ iprfront(maxfr),nxtfront(maxfr),
     &                 ityfront(maxfr),newfront(maxfr),
     &                 lstbond(maxfr),mwfront(maxfr),
     &                 loops(maxfr),ityloop1(maxfr)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      common /space/ lhead(6),lfree(50,2),lenf,idimf,lentot,lenmax
c
c     # put pointer "iptr" back to the free list
c
      if(itype .eq. 1) then
c        # for irregular cell
	 kirr = iptr
 10      if(nxtirr(kirr) .eq. 0) go to 12
	 kirr = nxtirr(kirr)
	 go to 10
c
 12      nxtirr(kirr) = lhead(1)
	 iprirr(lhead(1)) = kirr
	 lhead(1) = iptr
      elseif(itype .eq. 2) then
c        # for tracked front
         kpre = iprfront(iptr)
         knxt = iabs(nxtfront(iptr))
         nxtfront(kpre) = knxt
         if(knxt .eq. 0) go to 20
         iprfront(knxt) = kpre
c
c        # insert iptr to the free list
         klst = iprfront(lhead(2))
         iprfront(iptr) = klst
c
 20      continue
         nxtfront(iptr) = lhead(2)
         iprfront(lhead(2)) = iptr
         lhead(2) = iptr
         iptr = kpre
      elseif(itype .eq. 3) then
c        # for tracked bond
	 kbond = iptr
 30      if(nxtbond(kbond) .eq. 0) go to 32
	 kbond = nxtbond(kbond)
	 go to 30
c
 32      nxtbond(kbond) = lhead(3)
	 iprbond(lhead(3)) = kbond 
	 lhead(3) = iptr
      endif
c
      return
c
      end
