c
c -------------------------------------------------------------------
c
      subroutine setpre(lstgrd,lstfrt)
      implicit double precision (a-h,o-z)
      parameter(mxloc=4999999,maxfr=100,maxbd=5560)
      common /calloc/ alloc(mxloc)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkfront/ iprfront(maxfr),nxtfront(maxfr),
     &                 ityfront(maxfr),newfront(maxfr),
     &                 lstbond(maxfr),mwfront(maxfr),
     &                 loops(maxfr),ityloop1(maxfr)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ix(maxbd),jy(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      common /space/ lhead(6),lfree(50,2),lenf,idimf,lentot,lenmax
c
c     # preliminary set up of data structure
c
      do i=1,mxloc
         alloc(i) = 0.0d0
         enddo
c
c     # initialize linked list of alloc storage as well.
c     # first and last locations are dummy placeholders of zero words
c     # of allocation each, to avoid boundary cases.
      idimf = 50
      do i=1,idimf
         lfree(i,1) = 0
         lfree(i,2) = 0
         enddo
      lfree(3,1) = mxloc+2
      lfree(2,1) = 1
      lfree(2,2) = mxloc
      lenf       = 3
c
c     # set doubly linked list 
c
c     # for irregular cells
      do i=1,maxbd-1
         iprirr(i) = i-1
         nxtirr(i) = i+1
         enddo
      nxtirr(maxbd) = 0
c
c     # set starting grid pointer
      lhead(1) = 1
      lstgrd = lstptr(1)
c
c     # for tracked fronts
      do i=1,maxfr-1
         iprfront(i) = i-1
         nxtfront(i) = i+1
         enddo
      nxtfront(maxfr) = 0
c
c     # set starting front pointer
      lhead(2) = 1
      lstfrt = lstptr(2)
c
c     # for tracked bonds
      do i=1,maxbd-1
         iprbond(i) = i-1
         nxtbond(i) = i+1
         enddo
      nxtbond(maxbd) = 0
      lhead(3) = 1
c
      return
      end
