c
c -----------------------------------------------------------------
c
      subroutine stnfrt(kfront,newfr,irr,irrold,mitot,mjtot,
     &                  xlow,ylow,hx,hy,lstgrd)
      implicit double precision (a-h,o-z)
      parameter(maxfr=100,maxbd=5560)
      common /lkbond/ iprbond(maxbd),nxtbond(maxbd),itybond(maxbd),
     &                irrcell(2,maxbd),ixbond(maxbd),jybond(maxbd),
     &                points(2,2,maxbd),alfbond(maxbd),
     &                betabond(maxbd),spbond(2,maxbd)
      common /lkfront/ iprfront(maxfr),nxtfront(maxfr),
     &                 ityfront(maxfr),newfront(maxfr),
     &                 lstbond(maxfr),mwfront(maxfr),
     &                 loops(maxfr),ityloop1(maxfr)
      common /lkirr/ iprirr(maxbd),nxtirr(maxbd),ityirr(maxbd),
     &               ixc(maxbd),jyc(maxbd),ncells(maxbd),
     &               nbonds(maxbd),nbondc(6,maxbd),ar(6,maxbd),
     &               xcen(6,maxbd),ycen(6,maxbd),
     &               poly(6,10,2,maxbd)
      dimension irr(mitot,mjtot),irrold(mitot,mjtot)
c
c     # create stationary front
c
      ismall = 0
      newbd0 = lstbond(newfr)
c
      kbond = lstbond(kfront)
      do ibd=1,maxbd
         kbond = nxtbond(kbond)
	 if (kbond .eq. 0) go to 19
         ix = ixbond(kbond)
	 jy = jybond(kbond)
         iptr = irrold(ix,jy)
c
	 x0 = points(1,1,kbond)
	 y0 = points(1,2,kbond)
c
 10      continue
c        # check if boundary segement cut by a tracked interface
         kbond0 = nxtbond(kbond)
         iptr0 = irrold(ixbond(kbond0),jybond(kbond0))
	 if (iptr0 .ne. iptr) go to 15
	 kbond = kbond0
	 go to 10

 15      continue
	 x1 = points(2,1,kbond)
	 y1 = points(2,2,kbond)
c
c        # make irregular cell
         call mkirrc(irr,ix,jy,x0,y0,x1,y1,mitot,mjtot,xlow,ylow,
     &               hx,hy,lstgrd,newbd0,newbd,ismall)
c
         ityirr(irr(ix,jy)) = ityirr(irrold(ix,jy))
         enddo
 19      continue
c
      return
      end
